## qrupdate 1.0.1

=== src/Makefile ===
# Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
#
# Author: Jaroslav Hajek <highegg@gmail.com>
#
# This file is part of qrupdate.
#
# qrupdate is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, see
# <http://www.gnu.org/licenses/>.
#
include ../Makeconf

SRC = caxcpy.f cch1dn.f cch1up.f cchdex.f cchinx.f cchshx.f cgqvec.f   \
cqhqr.f cqr1up.f cqrdec.f cqrder.f cqrinc.f cqrinr.f cqrot.f cqrqh.f   \
cqrshc.f cqrtv1.f dch1dn.f dch1up.f dchdex.f dchinx.f dchshx.f         \
dgqvec.f dqhqr.f dqr1up.f dqrdec.f dqrder.f dqrinc.f dqrinr.f dqrot.f  \
dqrqh.f dqrshc.f dqrtv1.f sch1dn.f sch1up.f schdex.f schinx.f schshx.f \
sgqvec.f sqhqr.f sqr1up.f sqrdec.f sqrder.f sqrinc.f sqrinr.f sqrot.f  \
sqrqh.f sqrshc.f sqrtv1.f zaxcpy.f zch1dn.f zch1up.f zchdex.f zchinx.f \
zchshx.f zgqvec.f zqhqr.f zqr1up.f zqrdec.f zqrder.f zqrinc.f zqrinr.f \
zqrot.f zqrqh.f zqrshc.f zqrtv1.f

OBJS = $(SRC:%.f=%.o)

lib: ../libqrupdate.a

solib: ../libqrupdate.so

../libqrupdate.a: $(OBJS)
	ar -cr $@ $(OBJS)

../libqrupdate.so: $(OBJS)
	$(FC) $(FFLAGS) -shared -o $@ -Wl,-soname=libqrupdate.so.$(MAJOR) $(OBJS) \
		$(BLAS) $(LAPACK)

$(OBJS): %.o: %.f
	$(FC) $(FFLAGS) $(FPICFLAGS) -c $<

clean:
	rm -f $(OBJS)

install: install-shlib install-staticlib

install-shlib: ../libqrupdate.so
	install -D -m644 ../libqrupdate.so $(PREFIX)/lib/libqrupdate.so.$(VERSION)
	ln -s libqrupdate.so.$(VERSION) $(PREFIX)/lib/libqrupdate.so.$(MAJOR)
	ln -s libqrupdate.so.$(VERSION) $(PREFIX)/lib/libqrupdate.so

install-staticlib: ../libqrupdate.a
	install -D -m644 ../libqrupdate.a $(PREFIX)/lib/libqrupdate.a

=== test/Makefile ===
# Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
#
# Author: Jaroslav Hajek <highegg@gmail.com>
#
# This file is part of qrupdate.
#
# qrupdate is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, see
# <http://www.gnu.org/licenses/>.
#
include ../Makeconf

LIBS= $(BLAS) $(LAPACK)
PROGS=tqr1up tqrinc tqrdec tqrshc tqrinr tqrder \
      tch1up tch1dn tchinx tchdex tchshx
OUTS=$(PROGS:%=%.out)

tests: $(OUTS)
	./report_results $(OUTS)

$(OUTS): %.out: %
	./$< | tee $@

$(PROGS): % : %.f utils.o ../libqrupdate.a
	$(FC) $(FFLAGS) -o $@ $^ $(LIBS)

utils.o: utils.f
	$(FC) $(FFLAGS) -c $<

../libqrupdate.a:
	make -C ../ lib
	
clean: 
	rm -f *.o $(PROGS) $(OUTS)

## qrupdate 1.1.1

=== Makefile ===
# Copyright (C) 2008, 2009  VZLU Prague, a.s., Czech Republic
#
# Author: Jaroslav Hajek <highegg@gmail.com>
#
# This file is part of qrupdate.
#
# qrupdate is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, see
# <http://www.gnu.org/licenses/>.
#

include Makeconf

help:
	@echo
	@echo "The following targets are available:"
	@echo "   make help    - displays this help"
	@echo "   make lib     - compiles a static library"
	@echo "   make solib   - compiles a dynamic library"
	@echo "   make test    - compiles and runs the testsuite"
	@echo "   make clean   - cleans up everything"
	@echo "   make install - installs everything"

lib:
	make -C src/ lib
solib:
	make -C src/ solib
test: lib
	make -C test/

clean:
	rm -f libqrupdate.a libqrupdate.so
	make -C src/ clean
	make -C test/ clean

install:
	make -C src/ install

install-shlib:
	make -C src/ install-shlib

install-staticlib:
	make -C src/ install-staticlib

=== debian/changelog ===
qrupdate (1.1.1-1) unstable; urgency=low

  * Team upload
  * New upstream release
  * Package moved to debian science
  * Standards-Version updated to version 3.9.2
  * Rafael removed from uploaders (Closes: #571907)
  * Switch to dpkg-source 3.0 (quilt) format

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 04 Aug 2011 15:43:08 +0200

qrupdate (1.0.1-1) unstable; urgency=low

  * New upstream release.  The -march=native gcc option has been dropped
    and the package should compile correct on all architectures now.
    Closes: #519126
  * debian/control, debian/rules, debian/patches/*: Drop use of quilt,
    since all Debian patches are now applied upstream.

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 12 Mar 2009 02:56:40 +0100

qrupdate (1.0-1) unstable; urgency=low

  * Initial release (Closes: #512232)

 -- Jordi Gutiérrez Hermoso <jordigh@gmail.com>  Tue, 03 Feb 2009 20:59:19 -0600

=== debian/control ===
Source: qrupdate
Priority: optional
Maintainer:  Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jordi Gutiérrez Hermoso <jordigh@gmail.com>
Build-Depends: debhelper (>= 7), perl-base( >= 5.8.8), gfortran, libblas3gf, liblapack-dev
Standards-Version: 3.9.2
Section: libs
Homepage: http://qrupdate.sf.net
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/qrupdate/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packagesqrupdate/

Package: libqrupdate1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fast updates of QR and Cholesky decompositions
 qrupdate is a Fortran library for QR and Cholesky decompositions. It
 is most notably used by Octave.
 .
 This package contains the shared library.

Package: libqrupdate-dev
Section: libdevel
Architecture: any
Depends: libqrupdate1 (= ${binary:Version}), ${misc:Depends}
Description: Fast updates of QR and Cholesky decompositions -- static library
 qrupdate is a Fortran library for QR and Cholesky decompositions. It
 is most notably used by Octave.
 .
 This package contains the static library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export PREFIX=$(CURDIR)/debian/tmp/usr

build: build-stamp
build-stamp: 
	dh_testdir
	$(MAKE) lib
	$(MAKE) solib
	$(MAKE) test

#extract docs from sources
	cat src/*.f | perl debian/get-function-ref.pl > function-reference

	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	$(MAKE) clean
	rm -f function-reference
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep 
	dh_installdirs
	$(MAKE) install
	dh_install

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs -A
	dh_link
	dh_makeshlibs
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=3
http://sf.net/qrupdate/qrupdate-([\d.]+)\.tar\.gz

## qrupdate 1.1.2

=== src/Makefile ===
--- 
+++ 
@@ -28,19 +28,30 @@
 sgqvec.f sqhqr.f sqr1up.f sqrdec.f sqrder.f sqrinc.f sqrinr.f sqrot.f  \
 sqrqh.f sqrshc.f sqrtv1.f zaxcpy.f zch1dn.f zch1up.f zchdex.f zchinx.f \
 zchshx.f zgqvec.f zqhqr.f zqr1up.f zqrdec.f zqrder.f zqrinc.f zqrinr.f \
-zqrot.f zqrqh.f zqrshc.f zqrtv1.f
+zqrot.f zqrqh.f zqrshc.f zqrtv1.f \
+clu1up.f dlu1up.f slu1up.f zlu1up.f \
+clup1up.f dlup1up.f slup1up.f zlup1up.f
 
 OBJS = $(SRC:%.f=%.o)
 
 lib: ../libqrupdate.a
 
-solib: ../libqrupdate.so
+ifeq ($(shell uname),Darwin)
+SOEXT=.dylib
+else
+SOEXT=.so
+endif
+solib: ../libqrupdate$(SOEXT)
 
 ../libqrupdate.a: $(OBJS)
 	ar -cr $@ $(OBJS)
 
 ../libqrupdate.so: $(OBJS)
 	$(FC) $(FFLAGS) -shared -o $@ -Wl,-soname=libqrupdate.so.$(MAJOR) $(OBJS) \
+		$(BLAS) $(LAPACK)
+
+../libqrupdate.dylib: $(OBJS)
+	$(FC) $(FFLAGS) $(LDFLAGS) -dynamiclib -o $@ -install_name $(PREFIX)/$(LIBDIR)/libqrupdate.$(MAJOR).dylib $(OBJS) \
 		$(BLAS) $(LAPACK)
 
 $(OBJS): %.o: %.f
@@ -51,10 +62,17 @@
 
 install: install-shlib install-staticlib
 
-install-shlib: ../libqrupdate.so
-	install -D -m644 ../libqrupdate.so $(PREFIX)/lib/libqrupdate.so.$(VERSION)
-	ln -s libqrupdate.so.$(VERSION) $(PREFIX)/lib/libqrupdate.so.$(MAJOR)
-	ln -s libqrupdate.so.$(VERSION) $(PREFIX)/lib/libqrupdate.so
+install-shlib: ../libqrupdate$(SOEXT) install-lib$(SOEXT)
+
+install-lib.so:
+	install -D -m644 ../libqrupdate.so $(DESTDIR)$(PREFIX)/$(LIBDIR)/libqrupdate.so.$(VERSION)
+	ln -s libqrupdate.so.$(VERSION) $(DESTDIR)$(PREFIX)/$(LIBDIR)/libqrupdate.so.$(MAJOR)
+	ln -s libqrupdate.so.$(VERSION) $(DESTDIR)$(PREFIX)/$(LIBDIR)/libqrupdate.so
+
+install-lib.dylib:
+	install -D -m644 ../libqrupdate.dylib $(DESTDIR)$(PREFIX)/$(LIBDIR)/libqrupdate.$(VERSION).dylib
+	ln -s libqrupdate.$(VERSION).dylib $(DESTDIR)$(PREFIX)/$(LIBDIR)/libqrupdate.$(MAJOR).dylib
+	ln -s libqrupdate.$(VERSION).dylib $(DESTDIR)$(PREFIX)/$(LIBDIR)/libqrupdate.dylib
 
 install-staticlib: ../libqrupdate.a
-	install -D -m644 ../libqrupdate.a $(PREFIX)/lib/libqrupdate.a
+	install -D -m644 ../libqrupdate.a $(DESTDIR)$(PREFIX)/$(LIBDIR)/libqrupdate.a

=== test/Makefile ===
--- 
+++ 
@@ -22,13 +22,16 @@
 
 LIBS= $(BLAS) $(LAPACK)
 PROGS=tqr1up tqrinc tqrdec tqrshc tqrinr tqrder \
-      tch1up tch1dn tchinx tchdex tchshx
+      tch1up tch1dn tchinx tchdex tchshx \
+      tlu1up tlup1up
+
 OUTS=$(PROGS:%=%.out)
 
 tests: $(OUTS)
 	./report_results $(OUTS)
 
 $(OUTS): %.out: %
+	echo > $@
 	./$< | tee $@
 
 $(PROGS): % : %.f utils.o ../libqrupdate.a

=== debian/changelog ===
qrupdate (1.1.2-3) unstable; urgency=medium

  * d/rules: add option -V to dh_makeshlibs.
  * Add Build-Depends-Package field in symbols file
  * Update Vcs-* URLs for move to salsa
  * Bump to debhelper compat level 11
  * Add Rules-Requires-Root: no
  * Remove obsolete versioned B-D on dpkg-dev and perl-base
  * Add support for nodoc in DEB_BUILD_OPTIONS
  * Bump S-V to 4.2.1
  * Rewrite d/copyright using machine-readable format 1.0
  * Update Homepage URL
  * Bump d/watch to file format version 4

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 27 Oct 2018 09:48:18 +0200

qrupdate (1.1.2-2) unstable; urgency=medium

  * Update Vcs-* fields for new git repository.
  * Drop useless use of dh-exec.
  * Bump to debhelper compat level 10.
  * Bump Standards-Version to 3.9.8, no changes needed.
  * Drop Jordi Gutiérrez Hermoso from Uploader.
    Thanks Jordi for your past contributions to this package! (Closes: #842482)

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 30 Oct 2016 00:02:48 +0200

qrupdate (1.1.2-1) unstable; urgency=medium

  * Upload to unstable.
  * Bump to debhelper 9.
  * Add myself to Uploaders.
  * Use canonical URLs for Vcs-* fields.
  * Ship docs only in the -dev package.
  * Bump to Standards-Version 3.9.5.
  * Multi-archify the package.
  * Inject compilation and linking flags from dpkg-buildflags.
  * Rewrite debian/rules using dh.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 12 Feb 2014 20:45:46 +0100

qrupdate (1.1.2-1~exp1) experimental; urgency=low

  * Team upload
  * New upstream release
  * Standards-Version updated to version 3.9.3

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 14 Aug 2012 14:53:12 +0200

=== debian/control ===
Source: qrupdate
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Build-Depends: debhelper-compat (= 11),
               gfortran,
               libblas-dev,
               liblapack-dev
Standards-Version: 4.2.1
Section: libs
Homepage: https://qrupdate.sourceforge.io/
Vcs-Git: https://salsa.debian.org/science-team/qrupdate.git
Vcs-Browser: https://salsa.debian.org/science-team/qrupdate
Rules-Requires-Root: no

Package: libqrupdate1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fast updates of QR and Cholesky decompositions
 qrupdate is a Fortran library for QR and Cholesky decompositions. It
 is most notably used by Octave.
 .
 This package contains the shared library.

Package: libqrupdate-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libqrupdate1 (= ${binary:Version}), ${misc:Depends}
Description: Fast updates of QR and Cholesky decompositions -- static library
 qrupdate is a Fortran library for QR and Cholesky decompositions. It
 is most notably used by Octave.
 .
 This package contains the static library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_build:
	$(MAKE) lib FFLAGS="$(FFLAGS)" LDFLAGS="$(LDFLAGS)"
	$(MAKE) solib FFLAGS="$(FFLAGS)" LDFLAGS="$(LDFLAGS)"
	$(MAKE) test FFLAGS="$(FFLAGS)" LDFLAGS="$(LDFLAGS)"

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
#extract docs from sources
	cat src/*.f | perl debian/get-function-ref.pl > function-reference
endif

override_dh_auto_clean: 
	$(MAKE) clean
	rm -f function-reference

override_dh_auto_install:
	$(MAKE) install DESTDIR=../debian/tmp PREFIX=/usr LIBDIR=lib/$(DEB_HOST_MULTIARCH)

override_dh_makeshlibs:
	dh_makeshlibs -V

=== debian/watch ===
version=4
http://sf.net/qrupdate/ qrupdate-(.+)\.tar\.gz debian uupdate

## qrupdate 1.1.5

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.1.0)
CMAKE_POLICY(SET CMP0048 NEW)
PROJECT(qrupdate-ng VERSION 1.1.5 LANGUAGES Fortran)
ENABLE_TESTING()

# Options
OPTION(BUILD_SHARED_LIBS "Build shared libraries" ON)
OPTION(DEBUG "Enable Debug Symbol generation" OFF)

SET(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
IF ( DEBUG STREQUAL ON )
	SET (CMAKE_BUILD_TYPE "Debug")
	ADD_DEFINITIONS(-DDEBUG)
ENDIF()

IF(NOT CMAKE_BUILD_TYPE)
	SET (CMAKE_BUILD_TYPE "Release")
ENDIF()

# Required to work with Intel MKL
IF (CMAKE_Fortran_COMPILER_ID STREQUAL "Intel" OR BLA_VENDOR MATCHES "Intel.*")
	ENABLE_LANGUAGE(C)
ENDIF()

# Add addtional CMAKE Paths.
LIST(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")


INCLUDE(FortranCompilerSettings)
INCLUDE(GNUInstallDirs)

# IBM XLF Compilation
IF( CMAKE_Fortran_COMPILER_ID STREQUAL "XL")
	SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qfixed -qnosave")
ENDIF()



FIND_PACKAGE(BLAS REQUIRED)
MESSAGE(STATUS "BLAS Vendor: ${BLA_VENDOR}")
IF(NOT BLA_VENDOR STREQUAL "IBMESSL")
	FIND_PACKAGE(LAPACK REQUIRED)
ELSE()
	SET(LAPACK_MISSING_TARGET_NAME lapack_missing)
	INCLUDE(${CMAKE_SOURCE_DIR}/lapack-missing/LapackMissing.cmake)
	SET(LAPACK_FOUND TRUE)
	SET(LAPACK_LIBRARIES ${BLAS_LIBRARIES})
ENDIF()


ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(test)

INCLUDE(CMakePackageConfigHelpers)
WRITE_BASIC_PACKAGE_VERSION_FILE(
    qrupdateConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
 )
INSTALL(EXPORT qrupdatetargets
        FILE qrupdateTargets.cmake
        NAMESPACE qrupdate::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/qrupdate
)

CONFIGURE_FILE(qrupdate-config.cmake.in qrupdate-config.cmake @ONLY)
INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/qrupdate-config.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/qrupdateConfigVersion.cmake"
              DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/qrupdate
        )

CONFIGURE_FILE(qrupdate.pc.in qrupdate.pc @ONLY)
INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/qrupdate.pc"
              DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

MESSAGE(STATUS "------------ Build Information --------------")
MESSAGE(STATUS "CMAKE_Fortran_FLAGS:  ${CMAKE_Fortran_FLAGS}")
MESSAGE(STATUS "CMAKE_Fortran_FLAGS_DEBUG:  ${CMAKE_Fortran_FLAGS_DEBUG}")
MESSAGE(STATUS "CMAKE_Fortran_FLAGS_RELEASE:  ${CMAKE_Fortran_FLAGS_RELEASE}")
MESSAGE(STATUS "BLAS Libraries: ${BLAS_LIBRARIES}")
MESSAGE(STATUS "LAPACK Libraries: ${LAPACK_LIBRARIES}")
MESSAGE(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
MESSAGE(STATUS "Debug: ${DEBUG}")
MESSAGE(STATUS "Shared Libs: ${BUILD_SHARED_LIBS}")
MESSAGE(STATUS "---------------------------------------------")

=== lapack-missing/CMakeLists.txt ===
PROJECT(LAPACK_MISSING Fortran)
IF(${CMAKE_SOURCE_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
	cmake_minimum_required(VERSION 3.0)
	LIST(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules")

	MESSAGE(STATUS "essl-lapack standalone build")
	FIND_PACKAGE(BLAS REQUIRED)
	FIND_PACKAGE(LAPACK REQUIRED)
    SET(LAPACK_MISSING_TARGET_NAME lapack_missing)
ENDIF()

INCLUDE(${CMAKE_SOURCE_DIR}/LapackMissing.cmake)

=== src/CMakeLists.txt ===
SET(SRC
    caxcpy.f
    cch1dn.f
    cch1up.f
    cchdex.f
    cchinx.f
    cchshx.f
    cgqvec.f
    clu1up.f
    clup1up.f
    cqhqr.f
    cqr1up.f
    cqrdec.f
    cqrder.f
    cqrinc.f
    cqrinr.f
    cqrot.f
    cqrqh.f
    cqrshc.f
    cqrtv1.f
    dch1dn.f
    dch1up.f
    dchdex.f
    dchinx.f
    dchshx.f
    dgqvec.f
    dlu1up.f
    dlup1up.f
    dqhqr.f
    dqr1up.f
    dqrdec.f
    dqrder.f
    dqrinc.f
    dqrinr.f
    dqrot.f
    dqrqh.f
    dqrshc.f
    dqrtv1.f
    sch1dn.f
    sch1up.f
    schdex.f
    schinx.f
    schshx.f
    sgqvec.f
    slu1up.f
    slup1up.f
    sqhqr.f
    sqr1up.f
    sqrdec.f
    sqrder.f
    sqrinc.f
    sqrinr.f
    sqrot.f
    sqrqh.f
    sqrshc.f
    sqrtv1.f
    zaxcpy.f
    zch1dn.f
    zch1up.f
    zchdex.f
    zchinx.f
    zchshx.f
    zgqvec.f
    zlu1up.f
    zlup1up.f
    zqhqr.f
    zqr1up.f
    zqrdec.f
    zqrder.f
    zqrinc.f
    zqrinr.f
    zqrot.f
    zqrqh.f
    zqrshc.f
    zqrtv1.f
)

IF (TARGET lapack_missing) 
	ADD_LIBRARY(qrupdate ${SRC} $<TARGET_OBJECTS:lapack_missing>) 
ELSE()
	ADD_LIBRARY(qrupdate ${SRC})
ENDIF()
TARGET_LINK_LIBRARIES(qrupdate ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
SET_PROPERTY(TARGET qrupdate PROPERTY VERSION ${PROJECT_VERSION})
SET_PROPERTY(TARGET qrupdate PROPERTY SOVERSION ${PROJECT_VERSION_MAJOR})

INSTALL(TARGETS qrupdate
        EXPORT  qrupdatetargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        )

=== test/CMakeLists.txt ===
SET(UTILS_SRC utils.f)

ADD_LIBRARY(utils STATIC ${UTILS_SRC})

SET(TEST_PRGM
    tch1dn
    tch1up
    tchdex
    tchinx
    tchshx
    tlu1up
    tlup1up
    tqr1up
    tqrdec
    tqrder
    tqrinc
    tqrinr
    tqrshc
    )


IF ( CMAKE_CROSSCOMPILING AND CMAKE_SYSTEM_NAME MATCHES Windows )
    SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${Fortran_LOCAL_FLAGS}")
    FIND_PROGRAM(WINE NAMES wine wine32 wine64)
    IF ( NOT WINE )
        MESSAGE(FATAL_ERROR "Wine not found")
    ELSE()
        MESSAGE(STATUS "Wine found: ${WINE}")
    ENDIF()

    EXECUTE_PROCESS(COMMAND ${CMAKE_C_COMPILER} -print-search-dirs
        COMMAND grep programs
        COMMAND cut -d= -f2
        COMMAND sed -e "s/:/;/g"
        COMMAND tr -d "\n" OUTPUT_VARIABLE WINEPATH_TMP)
    SET(WINEPATH)
    SET(ENVPATH_TMP "$ENV{WINEPATH}")
    FOREACH ( P IN LISTS ENVPATH_TMP)
        SET(WINEPATH "${WINEPATH}\\;${P}")
    ENDFOREACH()
    FOREACH ( P IN LISTS CMAKE_FIND_ROOT_PATH )
        SET(WINEPATH "${WINEPATH}\\;${P}/bin")
        SET(WINEPATH "${WINEPATH}\\;${P}/lib")
    ENDFOREACH()


    FOREACH ( P IN LISTS WINEPATH_TMP )
        SET(WINEPATH "${WINEPATH}\\;${P}")
    ENDFOREACH()

    SET(WINEPATH "${CMAKE_BINARY_DIR}/src\\;${WINEPATH}")
    MESSAGE(STATUS "Setting WINEPATH for tests to ${WINEPATH}")
ENDIF()

IF (CMAKE_SYSTEM_NAME MATCHES "CYGWIN")
    MESSAGE(STATUS "CYGWIN build")
    MESSAGE("Set additional PATH for tests to ${CMAKE_BINARY_DIR}/src:/usr/lib/lapack")
    SET(ADDPATH  "${CMAKE_BINARY_DIR}/src:/usr/lib/lapack")
ENDIF()


FOREACH(TEST_CODE ${TEST_PRGM})
    ADD_EXECUTABLE(${TEST_CODE} ${TEST_CODE}.f)
    TARGET_LINK_LIBRARIES(${TEST_CODE} utils qrupdate )
    IF ( CMAKE_CROSSCOMPILING )
        IF ( CMAKE_SYSTEM_NAME MATCHES Windows)
            ADD_TEST(NAME test_${TEST_CODE} COMMAND ${WINE} ${CMAKE_CURRENT_BINARY_DIR}/${TEST_CODE}${CMAKE_EXECUTABLE_SUFFIX})
            SET_TESTS_PROPERTIES(test_${TEST_CODE} PROPERTIES ENVIRONMENT "WINEPATH=${WINEPATH}")
        ELSE()
            MESSAGE(WARNING "Cross-Compile checks are only possible from Linux to Windows.")
        ENDIF()
    ELSE ()
        ADD_TEST(NAME test_${TEST_CODE} COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${TEST_CODE})
        IF ( ADDPATH )
            SET_TESTS_PROPERTIES(test_${TEST_CODE} PROPERTIES ENVIRONMENT "PATH=${ADDPATH}:$ENV{PATH}")
        ENDIF()
    ENDIF()
ENDFOREACH()

=== debian/changelog ===
qrupdate (1.1.5-2) unstable; urgency=medium

  * cmake4.patch: new patch, fixes FTBFS against CMake 4 (Closes: #1113446)
  * Drop “Rules-Requires-Root: no”, which is now the default
  * Bump S-V to 4.7.2
  * d/watch: convert to format version 5
  * Fix location of DEP-12 d/upstream/metadata file
  * d/upstream/metadata: add bug database on GitHub mirror.
    Issues on the GitHub mirror are monitored and fixed in practice, especially
    given that user account creation is restricted on the GitLab instance of the
    main repository.

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 09 Oct 2025 02:11:31 +0200

qrupdate (1.1.5-1) unstable; urgency=medium

  * New upstream version 1.1.5
    Switch to new upstream: qrupdate-ng by Martin Köhler. (Closes: #1079939)
  * d/copyright: reflect upstream changes
  * Adapt to new CMake build system.
    In particular:
    – the static library is no longer shipped
    – pkg-config and CMake modules are now shipped
    – inject-ldflags.patch has been dropped
  * Bump Standards-Version to 4.7.0

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 16 Sep 2024 17:02:20 +0200

qrupdate (1.1.2-4) unstable; urgency=medium

  * Add -std=legacy to FFLAGS, needed since gfortran 10 (Closes: #957723)
  * Bump to debhelper 13
  * Bump to S-V 4.5.0

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 22 Jul 2020 12:58:29 +0200

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,16 @@
 Priority: optional
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Sébastien Villemot <sebastien@debian.org>
-Build-Depends: debhelper-compat (= 11),
+Build-Depends: debhelper-compat (= 13),
                gfortran,
                libblas-dev,
-               liblapack-dev
-Standards-Version: 4.2.1
+               liblapack-dev,
+               cmake
+Standards-Version: 4.7.2
 Section: libs
-Homepage: https://qrupdate.sourceforge.io/
+Homepage: https://gitlab.mpi-magdeburg.mpg.de/koehlerm/qrupdate-ng
 Vcs-Git: https://salsa.debian.org/science-team/qrupdate.git
 Vcs-Browser: https://salsa.debian.org/science-team/qrupdate
-Rules-Requires-Root: no
 
 Package: libqrupdate1
 Architecture: any
@@ -29,8 +29,8 @@
 Architecture: any
 Multi-Arch: same
 Depends: libqrupdate1 (= ${binary:Version}), ${misc:Depends}
-Description: Fast updates of QR and Cholesky decompositions -- static library
+Description: Fast updates of QR and Cholesky decompositions -- development files
  qrupdate is a Fortran library for QR and Cholesky decompositions. It
  is most notably used by Octave.
  .
- This package contains the static library.
+ This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@

# Ensure that we pick generic BLAS and LAPACK
override_dh_auto_configure:
	dh_auto_configure -- -DBLA_PREFER_PKGCONFIG=TRUE

execute_after_dh_auto_build:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
#extract docs from sources
	cat src/*.f | perl debian/get-function-ref.pl > function-reference
endif

execute_after_dh_auto_clean:
	rm -f function-reference

=== debian/watch ===
Version: 5

# Once #1116633 is fixed, can be simplified as:
# Template: Gitlab
# Dist: https://gitlab.mpi-magdeburg.mpg.de/koehlerm/qrupdate-ng/
# Uversion-Mangle: (unchanged)
Source: https://gitlab.mpi-magdeburg.mpg.de/koehlerm/qrupdate-ng/
Mode: gitlab
Matching-Pattern: .*@ANY_VERSION@
Pgp-Mode: none
Filename-Mangle: s/.*(@ARCHIVE_EXT@)/@PACKAGE@.tar.gz/
Uversion-Mangle: s/^v//; s/(\d)[_\.\-\+]?((?:RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/
